#ifndef IOTQUERY_H
#define IOTQUERY_H
#include <iostream>
#include "fcgio.h"
#include "fcgi_stdio.h"

#define DEFAULT_SIZE 128
#define OFFSET_MAX 0
#define OFFSET_OLD 4
#define OFFSET_NEW 12

class IoTQuery {
 public:
	IoTQuery(FCGX_Request * request);
	~IoTQuery();
	void processQuery();
	
 private:
	void sendResponse(char *data, int length);
	void getQuery();
	void getDirectory();
	void readData();
	bool checkDirectory();
	bool openStatusFile();
	void updateStatusFile();
	void decodeQuery();
	void getSlot();
	void putSlot();
	void removeOldestSlot();
	char * getSlotFileName(long long);
	
	FCGX_Request * request;
	char *data;
	char *directory;
	const char * uri;
	const char * query;
	const char * method;
	const char * iotcloudroot;
	long long length;
	long long oldestentry;
	long long newestentry;
	long long requestsequencenumber;
	int numqueueentries;
	int fd;
	bool reqGetSlot;
	bool reqPutSlot;
};
#endif
